#include <algorithm>
#include <functional>
#include <numeric>
#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstring>
#include <cassert>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <bitset>
#include <sstream>
//#include <unordered_set>
//#include <unordered_map>

using namespace std;

#define fore(i, l, r) for(int i = int(l); i < int(r); ++i)
#define fori(i, l, r) fore(i, l, (r) + 1)
#define forn(i, n) fore(i, 0, n)
#define sz(v) int((v).size())
#define all(v) (v).begin(), (v).end()
#define pb push_back
#define X first
#define Y second
#define mp make_pair

template<typename T> inline T abs(T a){ return ((a < 0) ? -a : a); }
template<typename T> inline T sqr(T a){ return a * a; }

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

const int INF = (int)1E9 + 7;
const ld EPS = 1E-9;
const ld PI = 3.1415926535897932384626433832795;

int getTime(){
    int h, m;
    scanf(" %d : %d ", &h, &m);
//    cerr << h << " " << m << endl;

    assert(0 <= h && h <= 23);
    assert(0 <= m && m <= 59);

    return h * 60 + m;
}

void solve(){
    int t1 = getTime();
    int t2 = getTime();
    int dist;
    cin >> dist;
    
    assert(t2 < t1);
    assert(1 <= dist && dist <= 180);
    
    ld firstWay = t1 - t2 + dist;
    ld secondWay = 0;
    
    if(t1 - t2 >= 2 * dist)
        secondWay = t1 - t2;
    else{
        t2 += dist;
        if(t1 <= t2){
            int w1 = t2 - t1;
            secondWay = dist + (dist - w1) / 2.0;
        }else{
            int w2 = t1 - t2;
            secondWay = dist + (dist - w2) / 2.0 + w2;
        }
    }
    
    cout.precision(1);
    cout << fixed;
    
    cout << firstWay << " " << secondWay << endl;
}

int main() {
    #ifdef ssu1
//    freopen("input.txt", "rt", stdin);
//    freopen("output.txt", "wt", stdout);
    #endif
    
    int ts;
    cin >> ts;
    
    assert(1 <= ts && ts <= 10000);
    
    forn(i, ts){
        solve();
    }
    return 0;
}


